var Parser = (function(){
  /*
   * Generated by PEG.js 0.7.0.
   *
   * http://pegjs.majda.cz/
   */
  
  function quote(s) {
    /*
     * ECMA-262, 5th ed., 7.8.4: All characters may appear literally in a
     * string literal except for the closing quote character, backslash,
     * carriage return, line separator, paragraph separator, and line feed.
     * Any character may appear in the form of an escape sequence.
     *
     * For portability, we also escape escape all control and non-ASCII
     * characters. Note that "\0" and "\v" escape sequences are not used
     * because JSHint does not like the first and IE the second.
     */
     return '"' + s
      .replace(/\\/g, '\\\\')  // backslash
      .replace(/"/g, '\\"')    // closing quote character
      .replace(/\x08/g, '\\b') // backspace
      .replace(/\t/g, '\\t')   // horizontal tab
      .replace(/\n/g, '\\n')   // line feed
      .replace(/\f/g, '\\f')   // form feed
      .replace(/\r/g, '\\r')   // carriage return
      .replace(/[\x00-\x07\x0B\x0E-\x1F\x80-\uFFFF]/g, escape)
      + '"';
  }
  
  var result = {
    /*
     * Parses the input with a generated parser. If the parsing is successfull,
     * returns a value explicitly or implicitly specified by the grammar from
     * which the parser was generated (see |PEG.buildParser|). If the parsing is
     * unsuccessful, throws |PEG.parser.SyntaxError| describing the error.
     */
    parse: function(input, startRule) {
      var parseFunctions = {
        "start": parse_start,
        "additive": parse_additive,
        "addop": parse_addop,
        "multiplicative": parse_multiplicative,
        "exponentative": parse_exponentative,
        "mulop": parse_mulop,
        "factor": parse_factor,
        "unop": parse_unop,
        "simplefunction": parse_simplefunction,
        "trigeomfunction": parse_trigeomfunction,
        "trifuncname": parse_trifuncname,
        "otherfunction": parse_otherfunction,
        "number": parse_number,
        "integer": parse_integer,
        "constant": parse_constant,
        "variable": parse_variable,
        "ws": parse_ws
      };
      
      if (startRule !== undefined) {
        if (parseFunctions[startRule] === undefined) {
          throw new Error("Invalid rule name: " + quote(startRule) + ".");
        }
      } else {
        startRule = "start";
      }
      
      var pos = 0;
      var reportFailures = 0;
      var rightmostFailuresPos = 0;
      var rightmostFailuresExpected = [];
      
      function padLeft(input, padding, length) {
        var result = input;
        
        var padLength = length - input.length;
        for (var i = 0; i < padLength; i++) {
          result = padding + result;
        }
        
        return result;
      }
      
      function escape(ch) {
        var charCode = ch.charCodeAt(0);
        var escapeChar;
        var length;
        
        if (charCode <= 0xFF) {
          escapeChar = 'x';
          length = 2;
        } else {
          escapeChar = 'u';
          length = 4;
        }
        
        return '\\' + escapeChar + padLeft(charCode.toString(16).toUpperCase(), '0', length);
      }
      
      function matchFailed(failure) {
        if (pos < rightmostFailuresPos) {
          return;
        }
        
        if (pos > rightmostFailuresPos) {
          rightmostFailuresPos = pos;
          rightmostFailuresExpected = [];
        }
        
        rightmostFailuresExpected.push(failure);
      }
      
      function parse_start() {
        var result0;
        var pos0;
        
        pos0 = pos;
        result0 = parse_additive();
        if (result0 !== null) {
          result0 = (function(offset, expression) {return expression;})(pos0, result0);
        }
        if (result0 === null) {
          pos = pos0;
        }
        return result0;
      }
      
      function parse_additive() {
        var result0, result1, result2, result3, result4, result5, result6, result7;
        var pos0, pos1, pos2;
        
        pos0 = pos;
        pos1 = pos;
        result0 = parse_ws();
        if (result0 !== null) {
          result1 = parse_multiplicative();
          if (result1 !== null) {
            result2 = parse_ws();
            if (result2 !== null) {
              result3 = [];
              pos2 = pos;
              result4 = parse_addop();
              if (result4 !== null) {
                result5 = parse_ws();
                if (result5 !== null) {
                  result6 = parse_multiplicative();
                  if (result6 !== null) {
                    result7 = parse_ws();
                    if (result7 !== null) {
                      result4 = [result4, result5, result6, result7];
                    } else {
                      result4 = null;
                      pos = pos2;
                    }
                  } else {
                    result4 = null;
                    pos = pos2;
                  }
                } else {
                  result4 = null;
                  pos = pos2;
                }
              } else {
                result4 = null;
                pos = pos2;
              }
              while (result4 !== null) {
                result3.push(result4);
                pos2 = pos;
                result4 = parse_addop();
                if (result4 !== null) {
                  result5 = parse_ws();
                  if (result5 !== null) {
                    result6 = parse_multiplicative();
                    if (result6 !== null) {
                      result7 = parse_ws();
                      if (result7 !== null) {
                        result4 = [result4, result5, result6, result7];
                      } else {
                        result4 = null;
                        pos = pos2;
                      }
                    } else {
                      result4 = null;
                      pos = pos2;
                    }
                  } else {
                    result4 = null;
                    pos = pos2;
                  }
                } else {
                  result4 = null;
                  pos = pos2;
                }
              }
              if (result3 !== null) {
                result0 = [result0, result1, result2, result3];
              } else {
                result0 = null;
                pos = pos1;
              }
            } else {
              result0 = null;
              pos = pos1;
            }
          } else {
            result0 = null;
            pos = pos1;
          }
        } else {
          result0 = null;
          pos = pos1;
        }
        if (result0 !== null) {
          result0 = (function(offset, head, tail) { 
        	  var result = head;
        	  for (var i = 0; i < tail.length; i++) {
        		  result = new BinaryExpression(tail[i][0], result, tail[i][2]);
        	  }
        	  return result;
          })(pos0, result0[1], result0[3]);
        }
        if (result0 === null) {
          pos = pos0;
        }
        return result0;
      }
      
      function parse_addop() {
        var result0;
        var pos0;
        
        pos0 = pos;
        if (input.charCodeAt(pos) === 43) {
          result0 = "+";
          pos++;
        } else {
          result0 = null;
          if (reportFailures === 0) {
            matchFailed("\"+\"");
          }
        }
        if (result0 !== null) {
          result0 = (function(offset) {return add ;})(pos0);
        }
        if (result0 === null) {
          pos = pos0;
        }
        if (result0 === null) {
          pos0 = pos;
          if (input.charCodeAt(pos) === 45) {
            result0 = "-";
            pos++;
          } else {
            result0 = null;
            if (reportFailures === 0) {
              matchFailed("\"-\"");
            }
          }
          if (result0 !== null) {
            result0 = (function(offset) {return sub ;})(pos0);
          }
          if (result0 === null) {
            pos = pos0;
          }
        }
        return result0;
      }
      
      function parse_multiplicative() {
        var result0, result1, result2, result3, result4, result5, result6, result7;
        var pos0, pos1, pos2;
        
        pos0 = pos;
        pos1 = pos;
        result0 = parse_ws();
        if (result0 !== null) {
          result1 = parse_exponentative();
          if (result1 !== null) {
            result2 = parse_ws();
            if (result2 !== null) {
              result3 = [];
              pos2 = pos;
              result4 = parse_mulop();
              if (result4 !== null) {
                result5 = parse_ws();
                if (result5 !== null) {
                  result6 = parse_exponentative();
                  if (result6 !== null) {
                    result7 = parse_ws();
                    if (result7 !== null) {
                      result4 = [result4, result5, result6, result7];
                    } else {
                      result4 = null;
                      pos = pos2;
                    }
                  } else {
                    result4 = null;
                    pos = pos2;
                  }
                } else {
                  result4 = null;
                  pos = pos2;
                }
              } else {
                result4 = null;
                pos = pos2;
              }
              while (result4 !== null) {
                result3.push(result4);
                pos2 = pos;
                result4 = parse_mulop();
                if (result4 !== null) {
                  result5 = parse_ws();
                  if (result5 !== null) {
                    result6 = parse_exponentative();
                    if (result6 !== null) {
                      result7 = parse_ws();
                      if (result7 !== null) {
                        result4 = [result4, result5, result6, result7];
                      } else {
                        result4 = null;
                        pos = pos2;
                      }
                    } else {
                      result4 = null;
                      pos = pos2;
                    }
                  } else {
                    result4 = null;
                    pos = pos2;
                  }
                } else {
                  result4 = null;
                  pos = pos2;
                }
              }
              if (result3 !== null) {
                result0 = [result0, result1, result2, result3];
              } else {
                result0 = null;
                pos = pos1;
              }
            } else {
              result0 = null;
              pos = pos1;
            }
          } else {
            result0 = null;
            pos = pos1;
          }
        } else {
          result0 = null;
          pos = pos1;
        }
        if (result0 !== null) {
          result0 = (function(offset, head, tail) {
        	  var result = head;
        	  for (var i = 0; i < tail.length; i++) {
        		  result = new BinaryExpression(tail[i][0], result, tail[i][2]);
        	  }
        	  return result;
          })(pos0, result0[1], result0[3]);
        }
        if (result0 === null) {
          pos = pos0;
        }
        return result0;
      }
      
      function parse_exponentative() {
        var result0, result1, result2, result3, result4, result5, result6, result7;
        var pos0, pos1, pos2;
        
        pos0 = pos;
        pos1 = pos;
        result0 = parse_ws();
        if (result0 !== null) {
          result1 = parse_factor();
          if (result1 !== null) {
            result2 = parse_ws();
            if (result2 !== null) {
              result3 = [];
              pos2 = pos;
              if (input.charCodeAt(pos) === 94) {
                result4 = "^";
                pos++;
              } else {
                result4 = null;
                if (reportFailures === 0) {
                  matchFailed("\"^\"");
                }
              }
              if (result4 !== null) {
                result5 = parse_ws();
                if (result5 !== null) {
                  result6 = parse_factor();
                  if (result6 !== null) {
                    result7 = parse_ws();
                    if (result7 !== null) {
                      result4 = [result4, result5, result6, result7];
                    } else {
                      result4 = null;
                      pos = pos2;
                    }
                  } else {
                    result4 = null;
                    pos = pos2;
                  }
                } else {
                  result4 = null;
                  pos = pos2;
                }
              } else {
                result4 = null;
                pos = pos2;
              }
              while (result4 !== null) {
                result3.push(result4);
                pos2 = pos;
                if (input.charCodeAt(pos) === 94) {
                  result4 = "^";
                  pos++;
                } else {
                  result4 = null;
                  if (reportFailures === 0) {
                    matchFailed("\"^\"");
                  }
                }
                if (result4 !== null) {
                  result5 = parse_ws();
                  if (result5 !== null) {
                    result6 = parse_factor();
                    if (result6 !== null) {
                      result7 = parse_ws();
                      if (result7 !== null) {
                        result4 = [result4, result5, result6, result7];
                      } else {
                        result4 = null;
                        pos = pos2;
                      }
                    } else {
                      result4 = null;
                      pos = pos2;
                    }
                  } else {
                    result4 = null;
                    pos = pos2;
                  }
                } else {
                  result4 = null;
                  pos = pos2;
                }
              }
              if (result3 !== null) {
                result0 = [result0, result1, result2, result3];
              } else {
                result0 = null;
                pos = pos1;
              }
            } else {
              result0 = null;
              pos = pos1;
            }
          } else {
            result0 = null;
            pos = pos1;
          }
        } else {
          result0 = null;
          pos = pos1;
        }
        if (result0 !== null) {
          result0 = (function(offset, head, tail) {
        	  var result = head;
        	  for (var i = 0; i < tail.length; i++) {
        		  result = new BinaryExpression(pow, result, tail[i][2]);
        	  }
        	  return result;
          })(pos0, result0[1], result0[3]);
        }
        if (result0 === null) {
          pos = pos0;
        }
        return result0;
      }
      
      function parse_mulop() {
        var result0;
        var pos0;
        
        pos0 = pos;
        if (input.charCodeAt(pos) === 42) {
          result0 = "*";
          pos++;
        } else {
          result0 = null;
          if (reportFailures === 0) {
            matchFailed("\"*\"");
          }
        }
        if (result0 !== null) {
          result0 = (function(offset) {return mul ;})(pos0);
        }
        if (result0 === null) {
          pos = pos0;
        }
        if (result0 === null) {
          pos0 = pos;
          if (input.charCodeAt(pos) === 47) {
            result0 = "/";
            pos++;
          } else {
            result0 = null;
            if (reportFailures === 0) {
              matchFailed("\"/\"");
            }
          }
          if (result0 !== null) {
            result0 = (function(offset) {return div ;})(pos0);
          }
          if (result0 === null) {
            pos = pos0;
          }
        }
        return result0;
      }
      
      function parse_factor() {
        var result0, result1, result2;
        var pos0, pos1;
        
        pos0 = pos;
        result0 = parse_simplefunction();
        if (result0 !== null) {
          result0 = (function(offset, sfunc) {return sfunc;})(pos0, result0);
        }
        if (result0 === null) {
          pos = pos0;
        }
        if (result0 === null) {
          pos0 = pos;
          pos1 = pos;
          result0 = parse_number();
          if (result0 === null) {
            result0 = parse_variable();
            if (result0 === null) {
              result0 = parse_constant();
            }
          }
          if (result0 !== null) {
            result1 = [];
            result2 = parse_variable();
            if (result2 === null) {
              result2 = parse_constant();
            }
            while (result2 !== null) {
              result1.push(result2);
              result2 = parse_variable();
              if (result2 === null) {
                result2 = parse_constant();
              }
            }
            if (result1 !== null) {
              result0 = [result0, result1];
            } else {
              result0 = null;
              pos = pos1;
            }
          } else {
            result0 = null;
            pos = pos1;
          }
          if (result0 !== null) {
            result0 = (function(offset, head, tail) {
          	  var result = head;
          	  for (var i = 0; i < tail.length; i++) {
          		  console.log(tail[i][0]);
          		  result = new BinaryExpression(mul, result, tail[i]);
          	  }
          	  return result;
            })(pos0, result0[0], result0[1]);
          }
          if (result0 === null) {
            pos = pos0;
          }
          if (result0 === null) {
            pos0 = pos;
            result0 = parse_number();
            if (result0 !== null) {
              result0 = (function(offset, number) {return number;})(pos0, result0);
            }
            if (result0 === null) {
              pos = pos0;
            }
            if (result0 === null) {
              pos0 = pos;
              pos1 = pos;
              if (input.charCodeAt(pos) === 40) {
                result0 = "(";
                pos++;
              } else {
                result0 = null;
                if (reportFailures === 0) {
                  matchFailed("\"(\"");
                }
              }
              if (result0 !== null) {
                result1 = parse_additive();
                if (result1 !== null) {
                  if (input.charCodeAt(pos) === 41) {
                    result2 = ")";
                    pos++;
                  } else {
                    result2 = null;
                    if (reportFailures === 0) {
                      matchFailed("\")\"");
                    }
                  }
                  if (result2 !== null) {
                    result0 = [result0, result1, result2];
                  } else {
                    result0 = null;
                    pos = pos1;
                  }
                } else {
                  result0 = null;
                  pos = pos1;
                }
              } else {
                result0 = null;
                pos = pos1;
              }
              if (result0 !== null) {
                result0 = (function(offset, additive) {return additive;})(pos0, result0[1]);
              }
              if (result0 === null) {
                pos = pos0;
              }
              if (result0 === null) {
                pos0 = pos;
                pos1 = pos;
                result0 = parse_unop();
                if (result0 !== null) {
                  result1 = parse_factor();
                  if (result1 !== null) {
                    result0 = [result0, result1];
                  } else {
                    result0 = null;
                    pos = pos1;
                  }
                } else {
                  result0 = null;
                  pos = pos1;
                }
                if (result0 !== null) {
                  result0 = (function(offset, unary, factor) {return new UnaryExpression(unary, factor);})(pos0, result0[0], result0[1]);
                }
                if (result0 === null) {
                  pos = pos0;
                }
              }
            }
          }
        }
        return result0;
      }
      
      function parse_unop() {
        var result0;
        var pos0;
        
        pos0 = pos;
        if (input.charCodeAt(pos) === 45) {
          result0 = "-";
          pos++;
        } else {
          result0 = null;
          if (reportFailures === 0) {
            matchFailed("\"-\"");
          }
        }
        if (result0 !== null) {
          result0 = (function(offset) {return minus;})(pos0);
        }
        if (result0 === null) {
          pos = pos0;
        }
        return result0;
      }
      
      function parse_simplefunction() {
        var result0;
        var pos0;
        
        pos0 = pos;
        result0 = parse_trigeomfunction();
        if (result0 !== null) {
          result0 = (function(offset, tri) {return tri;})(pos0, result0);
        }
        if (result0 === null) {
          pos = pos0;
        }
        if (result0 === null) {
          pos0 = pos;
          result0 = parse_otherfunction();
          if (result0 !== null) {
            result0 = (function(offset, other) {return other;})(pos0, result0);
          }
          if (result0 === null) {
            pos = pos0;
          }
        }
        return result0;
      }
      
      function parse_trigeomfunction() {
        var result0, result1, result2, result3, result4, result5;
        var pos0, pos1;
        
        pos0 = pos;
        pos1 = pos;
        result0 = parse_trifuncname();
        if (result0 !== null) {
          if (input.charCodeAt(pos) === 40) {
            result1 = "(";
            pos++;
          } else {
            result1 = null;
            if (reportFailures === 0) {
              matchFailed("\"(\"");
            }
          }
          if (result1 !== null) {
            result2 = parse_ws();
            if (result2 !== null) {
              result3 = parse_additive();
              if (result3 !== null) {
                result4 = parse_ws();
                if (result4 !== null) {
                  if (input.charCodeAt(pos) === 41) {
                    result5 = ")";
                    pos++;
                  } else {
                    result5 = null;
                    if (reportFailures === 0) {
                      matchFailed("\")\"");
                    }
                  }
                  if (result5 !== null) {
                    result0 = [result0, result1, result2, result3, result4, result5];
                  } else {
                    result0 = null;
                    pos = pos1;
                  }
                } else {
                  result0 = null;
                  pos = pos1;
                }
              } else {
                result0 = null;
                pos = pos1;
              }
            } else {
              result0 = null;
              pos = pos1;
            }
          } else {
            result0 = null;
            pos = pos1;
          }
        } else {
          result0 = null;
          pos = pos1;
        }
        if (result0 !== null) {
          result0 = (function(offset, funcname, arg) {return new Func(funcname, arg);})(pos0, result0[0], result0[3]);
        }
        if (result0 === null) {
          pos = pos0;
        }
        return result0;
      }
      
      function parse_trifuncname() {
        var result0;
        var pos0;
        
        pos0 = pos;
        if (input.substr(pos, 4) === "sinh") {
          result0 = "sinh";
          pos += 4;
        } else {
          result0 = null;
          if (reportFailures === 0) {
            matchFailed("\"sinh\"");
          }
        }
        if (result0 !== null) {
          result0 = (function(offset) {return sinh; })(pos0);
        }
        if (result0 === null) {
          pos = pos0;
        }
        if (result0 === null) {
          pos0 = pos;
          if (input.substr(pos, 4) === "cosh") {
            result0 = "cosh";
            pos += 4;
          } else {
            result0 = null;
            if (reportFailures === 0) {
              matchFailed("\"cosh\"");
            }
          }
          if (result0 !== null) {
            result0 = (function(offset) {return  cosh; })(pos0);
          }
          if (result0 === null) {
            pos = pos0;
          }
          if (result0 === null) {
            pos0 = pos;
            if (input.substr(pos, 4) === "tanh") {
              result0 = "tanh";
              pos += 4;
            } else {
              result0 = null;
              if (reportFailures === 0) {
                matchFailed("\"tanh\"");
              }
            }
            if (result0 !== null) {
              result0 = (function(offset) {return tanh; })(pos0);
            }
            if (result0 === null) {
              pos = pos0;
            }
            if (result0 === null) {
              pos0 = pos;
              if (input.substr(pos, 4) === "coth") {
                result0 = "coth";
                pos += 4;
              } else {
                result0 = null;
                if (reportFailures === 0) {
                  matchFailed("\"coth\"");
                }
              }
              if (result0 !== null) {
                result0 = (function(offset) {return coth; })(pos0);
              }
              if (result0 === null) {
                pos = pos0;
              }
              if (result0 === null) {
                pos0 = pos;
                if (input.substr(pos, 6) === "arsinh") {
                  result0 = "arsinh";
                  pos += 6;
                } else {
                  result0 = null;
                  if (reportFailures === 0) {
                    matchFailed("\"arsinh\"");
                  }
                }
                if (result0 !== null) {
                  result0 = (function(offset) {return arsinh; })(pos0);
                }
                if (result0 === null) {
                  pos = pos0;
                }
                if (result0 === null) {
                  pos0 = pos;
                  if (input.substr(pos, 6) === "arcosh") {
                    result0 = "arcosh";
                    pos += 6;
                  } else {
                    result0 = null;
                    if (reportFailures === 0) {
                      matchFailed("\"arcosh\"");
                    }
                  }
                  if (result0 !== null) {
                    result0 = (function(offset) {return arcosh; })(pos0);
                  }
                  if (result0 === null) {
                    pos = pos0;
                  }
                  if (result0 === null) {
                    pos0 = pos;
                    if (input.substr(pos, 3) === "cos") {
                      result0 = "cos";
                      pos += 3;
                    } else {
                      result0 = null;
                      if (reportFailures === 0) {
                        matchFailed("\"cos\"");
                      }
                    }
                    if (result0 !== null) {
                      result0 = (function(offset) {return cos; })(pos0);
                    }
                    if (result0 === null) {
                      pos = pos0;
                    }
                    if (result0 === null) {
                      pos0 = pos;
                      if (input.substr(pos, 3) === "sin") {
                        result0 = "sin";
                        pos += 3;
                      } else {
                        result0 = null;
                        if (reportFailures === 0) {
                          matchFailed("\"sin\"");
                        }
                      }
                      if (result0 !== null) {
                        result0 = (function(offset) {return sin; })(pos0);
                      }
                      if (result0 === null) {
                        pos = pos0;
                      }
                      if (result0 === null) {
                        pos0 = pos;
                        if (input.substr(pos, 3) === "tan") {
                          result0 = "tan";
                          pos += 3;
                        } else {
                          result0 = null;
                          if (reportFailures === 0) {
                            matchFailed("\"tan\"");
                          }
                        }
                        if (result0 !== null) {
                          result0 = (function(offset) {return tan; })(pos0);
                        }
                        if (result0 === null) {
                          pos = pos0;
                        }
                        if (result0 === null) {
                          pos0 = pos;
                          if (input.substr(pos, 3) === "cot") {
                            result0 = "cot";
                            pos += 3;
                          } else {
                            result0 = null;
                            if (reportFailures === 0) {
                              matchFailed("\"cot\"");
                            }
                          }
                          if (result0 !== null) {
                            result0 = (function(offset) {return cot; })(pos0);
                          }
                          if (result0 === null) {
                            pos = pos0;
                          }
                          if (result0 === null) {
                            pos0 = pos;
                            if (input.substr(pos, 6) === "arcsin") {
                              result0 = "arcsin";
                              pos += 6;
                            } else {
                              result0 = null;
                              if (reportFailures === 0) {
                                matchFailed("\"arcsin\"");
                              }
                            }
                            if (result0 !== null) {
                              result0 = (function(offset) {return asin; })(pos0);
                            }
                            if (result0 === null) {
                              pos = pos0;
                            }
                            if (result0 === null) {
                              pos0 = pos;
                              if (input.substr(pos, 6) === "arccos") {
                                result0 = "arccos";
                                pos += 6;
                              } else {
                                result0 = null;
                                if (reportFailures === 0) {
                                  matchFailed("\"arccos\"");
                                }
                              }
                              if (result0 !== null) {
                                result0 = (function(offset) {return acos; })(pos0);
                              }
                              if (result0 === null) {
                                pos = pos0;
                              }
                              if (result0 === null) {
                                pos0 = pos;
                                if (input.substr(pos, 6) === "arctan") {
                                  result0 = "arctan";
                                  pos += 6;
                                } else {
                                  result0 = null;
                                  if (reportFailures === 0) {
                                    matchFailed("\"arctan\"");
                                  }
                                }
                                if (result0 !== null) {
                                  result0 = (function(offset) {return atan; })(pos0);
                                }
                                if (result0 === null) {
                                  pos = pos0;
                                }
                                if (result0 === null) {
                                  pos0 = pos;
                                  if (input.substr(pos, 6) === "arccot") {
                                    result0 = "arccot";
                                    pos += 6;
                                  } else {
                                    result0 = null;
                                    if (reportFailures === 0) {
                                      matchFailed("\"arccot\"");
                                    }
                                  }
                                  if (result0 !== null) {
                                    result0 = (function(offset) {return acot; })(pos0);
                                  }
                                  if (result0 === null) {
                                    pos = pos0;
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
        return result0;
      }
      
      function parse_otherfunction() {
        var result0, result1, result2, result3, result4, result5, result6, result7, result8, result9;
        var pos0, pos1;
        
        pos0 = pos;
        pos1 = pos;
        if (input.substr(pos, 3) === "pow") {
          result0 = "pow";
          pos += 3;
        } else {
          result0 = null;
          if (reportFailures === 0) {
            matchFailed("\"pow\"");
          }
        }
        if (result0 !== null) {
          if (input.charCodeAt(pos) === 40) {
            result1 = "(";
            pos++;
          } else {
            result1 = null;
            if (reportFailures === 0) {
              matchFailed("\"(\"");
            }
          }
          if (result1 !== null) {
            result2 = parse_ws();
            if (result2 !== null) {
              result3 = parse_additive();
              if (result3 !== null) {
                result4 = parse_ws();
                if (result4 !== null) {
                  if (input.charCodeAt(pos) === 44) {
                    result5 = ",";
                    pos++;
                  } else {
                    result5 = null;
                    if (reportFailures === 0) {
                      matchFailed("\",\"");
                    }
                  }
                  if (result5 !== null) {
                    result6 = parse_ws();
                    if (result6 !== null) {
                      result7 = parse_additive();
                      if (result7 !== null) {
                        result8 = parse_ws();
                        if (result8 !== null) {
                          if (input.charCodeAt(pos) === 41) {
                            result9 = ")";
                            pos++;
                          } else {
                            result9 = null;
                            if (reportFailures === 0) {
                              matchFailed("\")\"");
                            }
                          }
                          if (result9 !== null) {
                            result0 = [result0, result1, result2, result3, result4, result5, result6, result7, result8, result9];
                          } else {
                            result0 = null;
                            pos = pos1;
                          }
                        } else {
                          result0 = null;
                          pos = pos1;
                        }
                      } else {
                        result0 = null;
                        pos = pos1;
                      }
                    } else {
                      result0 = null;
                      pos = pos1;
                    }
                  } else {
                    result0 = null;
                    pos = pos1;
                  }
                } else {
                  result0 = null;
                  pos = pos1;
                }
              } else {
                result0 = null;
                pos = pos1;
              }
            } else {
              result0 = null;
              pos = pos1;
            }
          } else {
            result0 = null;
            pos = pos1;
          }
        } else {
          result0 = null;
          pos = pos1;
        }
        if (result0 !== null) {
          result0 = (function(offset, base, exp) {return new BinaryExpression(pow, base,exp);})(pos0, result0[3], result0[7]);
        }
        if (result0 === null) {
          pos = pos0;
        }
        if (result0 === null) {
          pos0 = pos;
          pos1 = pos;
          if (input.substr(pos, 2) === "ln") {
            result0 = "ln";
            pos += 2;
          } else {
            result0 = null;
            if (reportFailures === 0) {
              matchFailed("\"ln\"");
            }
          }
          if (result0 !== null) {
            if (input.charCodeAt(pos) === 40) {
              result1 = "(";
              pos++;
            } else {
              result1 = null;
              if (reportFailures === 0) {
                matchFailed("\"(\"");
              }
            }
            if (result1 !== null) {
              result2 = parse_ws();
              if (result2 !== null) {
                result3 = parse_additive();
                if (result3 !== null) {
                  result4 = parse_ws();
                  if (result4 !== null) {
                    if (input.charCodeAt(pos) === 41) {
                      result5 = ")";
                      pos++;
                    } else {
                      result5 = null;
                      if (reportFailures === 0) {
                        matchFailed("\")\"");
                      }
                    }
                    if (result5 !== null) {
                      result0 = [result0, result1, result2, result3, result4, result5];
                    } else {
                      result0 = null;
                      pos = pos1;
                    }
                  } else {
                    result0 = null;
                    pos = pos1;
                  }
                } else {
                  result0 = null;
                  pos = pos1;
                }
              } else {
                result0 = null;
                pos = pos1;
              }
            } else {
              result0 = null;
              pos = pos1;
            }
          } else {
            result0 = null;
            pos = pos1;
          }
          if (result0 !== null) {
            result0 = (function(offset, arg) {return new Func(log,arg); })(pos0, result0[3]);
          }
          if (result0 === null) {
            pos = pos0;
          }
          if (result0 === null) {
            pos0 = pos;
            pos1 = pos;
            if (input.substr(pos, 2) === "lb") {
              result0 = "lb";
              pos += 2;
            } else {
              result0 = null;
              if (reportFailures === 0) {
                matchFailed("\"lb\"");
              }
            }
            if (result0 !== null) {
              if (input.charCodeAt(pos) === 40) {
                result1 = "(";
                pos++;
              } else {
                result1 = null;
                if (reportFailures === 0) {
                  matchFailed("\"(\"");
                }
              }
              if (result1 !== null) {
                result2 = parse_ws();
                if (result2 !== null) {
                  result3 = parse_additive();
                  if (result3 !== null) {
                    result4 = parse_ws();
                    if (result4 !== null) {
                      if (input.charCodeAt(pos) === 41) {
                        result5 = ")";
                        pos++;
                      } else {
                        result5 = null;
                        if (reportFailures === 0) {
                          matchFailed("\")\"");
                        }
                      }
                      if (result5 !== null) {
                        result0 = [result0, result1, result2, result3, result4, result5];
                      } else {
                        result0 = null;
                        pos = pos1;
                      }
                    } else {
                      result0 = null;
                      pos = pos1;
                    }
                  } else {
                    result0 = null;
                    pos = pos1;
                  }
                } else {
                  result0 = null;
                  pos = pos1;
                }
              } else {
                result0 = null;
                pos = pos1;
              }
            } else {
              result0 = null;
              pos = pos1;
            }
            if (result0 !== null) {
              result0 = (function(offset, arg) {return  new Func(log2, arg); })(pos0, result0[3]);
            }
            if (result0 === null) {
              pos = pos0;
            }
            if (result0 === null) {
              pos0 = pos;
              pos1 = pos;
              if (input.substr(pos, 3) === "log") {
                result0 = "log";
                pos += 3;
              } else {
                result0 = null;
                if (reportFailures === 0) {
                  matchFailed("\"log\"");
                }
              }
              if (result0 !== null) {
                if (input.charCodeAt(pos) === 40) {
                  result1 = "(";
                  pos++;
                } else {
                  result1 = null;
                  if (reportFailures === 0) {
                    matchFailed("\"(\"");
                  }
                }
                if (result1 !== null) {
                  result2 = parse_ws();
                  if (result2 !== null) {
                    result3 = parse_additive();
                    if (result3 !== null) {
                      result4 = parse_ws();
                      if (result4 !== null) {
                        if (input.charCodeAt(pos) === 41) {
                          result5 = ")";
                          pos++;
                        } else {
                          result5 = null;
                          if (reportFailures === 0) {
                            matchFailed("\")\"");
                          }
                        }
                        if (result5 !== null) {
                          result0 = [result0, result1, result2, result3, result4, result5];
                        } else {
                          result0 = null;
                          pos = pos1;
                        }
                      } else {
                        result0 = null;
                        pos = pos1;
                      }
                    } else {
                      result0 = null;
                      pos = pos1;
                    }
                  } else {
                    result0 = null;
                    pos = pos1;
                  }
                } else {
                  result0 = null;
                  pos = pos1;
                }
              } else {
                result0 = null;
                pos = pos1;
              }
              if (result0 !== null) {
                result0 = (function(offset, arg) {return new Func(log10,arg);})(pos0, result0[3]);
              }
              if (result0 === null) {
                pos = pos0;
              }
              if (result0 === null) {
                pos0 = pos;
                pos1 = pos;
                if (input.substr(pos, 4) === "sqrt") {
                  result0 = "sqrt";
                  pos += 4;
                } else {
                  result0 = null;
                  if (reportFailures === 0) {
                    matchFailed("\"sqrt\"");
                  }
                }
                if (result0 !== null) {
                  if (input.charCodeAt(pos) === 40) {
                    result1 = "(";
                    pos++;
                  } else {
                    result1 = null;
                    if (reportFailures === 0) {
                      matchFailed("\"(\"");
                    }
                  }
                  if (result1 !== null) {
                    result2 = parse_ws();
                    if (result2 !== null) {
                      result3 = parse_additive();
                      if (result3 !== null) {
                        result4 = parse_ws();
                        if (result4 !== null) {
                          if (input.charCodeAt(pos) === 41) {
                            result5 = ")";
                            pos++;
                          } else {
                            result5 = null;
                            if (reportFailures === 0) {
                              matchFailed("\")\"");
                            }
                          }
                          if (result5 !== null) {
                            result0 = [result0, result1, result2, result3, result4, result5];
                          } else {
                            result0 = null;
                            pos = pos1;
                          }
                        } else {
                          result0 = null;
                          pos = pos1;
                        }
                      } else {
                        result0 = null;
                        pos = pos1;
                      }
                    } else {
                      result0 = null;
                      pos = pos1;
                    }
                  } else {
                    result0 = null;
                    pos = pos1;
                  }
                } else {
                  result0 = null;
                  pos = pos1;
                }
                if (result0 !== null) {
                  result0 = (function(offset, arg) {return new Func(sqrt, arg);})(pos0, result0[3]);
                }
                if (result0 === null) {
                  pos = pos0;
                }
              }
            }
          }
        }
        return result0;
      }
      
      function parse_number() {
        var result0, result1, result2, result3;
        var pos0, pos1, pos2;
        
        pos0 = pos;
        pos1 = pos;
        if (/^[0-9]/.test(input.charAt(pos))) {
          result1 = input.charAt(pos);
          pos++;
        } else {
          result1 = null;
          if (reportFailures === 0) {
            matchFailed("[0-9]");
          }
        }
        if (result1 !== null) {
          result0 = [];
          while (result1 !== null) {
            result0.push(result1);
            if (/^[0-9]/.test(input.charAt(pos))) {
              result1 = input.charAt(pos);
              pos++;
            } else {
              result1 = null;
              if (reportFailures === 0) {
                matchFailed("[0-9]");
              }
            }
          }
        } else {
          result0 = null;
        }
        if (result0 !== null) {
          pos2 = pos;
          if (input.charCodeAt(pos) === 46) {
            result1 = ".";
            pos++;
          } else {
            result1 = null;
            if (reportFailures === 0) {
              matchFailed("\".\"");
            }
          }
          if (result1 !== null) {
            result2 = [];
            if (/^[0-9]/.test(input.charAt(pos))) {
              result3 = input.charAt(pos);
              pos++;
            } else {
              result3 = null;
              if (reportFailures === 0) {
                matchFailed("[0-9]");
              }
            }
            while (result3 !== null) {
              result2.push(result3);
              if (/^[0-9]/.test(input.charAt(pos))) {
                result3 = input.charAt(pos);
                pos++;
              } else {
                result3 = null;
                if (reportFailures === 0) {
                  matchFailed("[0-9]");
                }
              }
            }
            if (result2 !== null) {
              result1 = [result1, result2];
            } else {
              result1 = null;
              pos = pos2;
            }
          } else {
            result1 = null;
            pos = pos2;
          }
          result1 = result1 !== null ? result1 : "";
          if (result1 !== null) {
            result0 = [result0, result1];
          } else {
            result0 = null;
            pos = pos1;
          }
        } else {
          result0 = null;
          pos = pos1;
        }
        if (result0 !== null) {
          result0 = (function(offset, digits) {return  new Num(parseFloat(flatten(digits).join(""), 10));})(pos0, result0);
        }
        if (result0 === null) {
          pos = pos0;
        }
        return result0;
      }
      
      function parse_integer() {
        var result0, result1;
        var pos0;
        
        pos0 = pos;
        if (/^[0-9]/.test(input.charAt(pos))) {
          result1 = input.charAt(pos);
          pos++;
        } else {
          result1 = null;
          if (reportFailures === 0) {
            matchFailed("[0-9]");
          }
        }
        if (result1 !== null) {
          result0 = [];
          while (result1 !== null) {
            result0.push(result1);
            if (/^[0-9]/.test(input.charAt(pos))) {
              result1 = input.charAt(pos);
              pos++;
            } else {
              result1 = null;
              if (reportFailures === 0) {
                matchFailed("[0-9]");
              }
            }
          }
        } else {
          result0 = null;
        }
        if (result0 !== null) {
          result0 = (function(offset, digits) { return new Num(parseInt(digits.join(""), 10)); })(pos0, result0);
        }
        if (result0 === null) {
          pos = pos0;
        }
        return result0;
      }
      
      function parse_constant() {
        var result0;
        var pos0;
        
        pos0 = pos;
        if (input.charCodeAt(pos) === 101) {
          result0 = "e";
          pos++;
        } else {
          result0 = null;
          if (reportFailures === 0) {
            matchFailed("\"e\"");
          }
        }
        if (result0 !== null) {
          result0 = (function(offset) {return new Num(Math.E);})(pos0);
        }
        if (result0 === null) {
          pos = pos0;
        }
        if (result0 === null) {
          pos0 = pos;
          if (input.substr(pos, 2) === "PI") {
            result0 = "PI";
            pos += 2;
          } else {
            result0 = null;
            if (reportFailures === 0) {
              matchFailed("\"PI\"");
            }
          }
          if (result0 !== null) {
            result0 = (function(offset) {return new Num(Math.PI); })(pos0);
          }
          if (result0 === null) {
            pos = pos0;
          }
          if (result0 === null) {
            pos0 = pos;
            if (/^[a-df-w]/.test(input.charAt(pos))) {
              result0 = input.charAt(pos);
              pos++;
            } else {
              result0 = null;
              if (reportFailures === 0) {
                matchFailed("[a-df-w]");
              }
            }
            if (result0 !== null) {
              result0 = (function(offset, constant) {return new Variable(constant); })(pos0, result0);
            }
            if (result0 === null) {
              pos = pos0;
            }
          }
        }
        return result0;
      }
      
      function parse_variable() {
        var result0;
        var pos0;
        
        pos0 = pos;
        if (input.charCodeAt(pos) === 120) {
          result0 = "x";
          pos++;
        } else {
          result0 = null;
          if (reportFailures === 0) {
            matchFailed("\"x\"");
          }
        }
        if (result0 !== null) {
          result0 = (function(offset) {return new Variable("x"); })(pos0);
        }
        if (result0 === null) {
          pos = pos0;
        }
        if (result0 === null) {
          pos0 = pos;
          if (input.charCodeAt(pos) === 121) {
            result0 = "y";
            pos++;
          } else {
            result0 = null;
            if (reportFailures === 0) {
              matchFailed("\"y\"");
            }
          }
          if (result0 !== null) {
            result0 = (function(offset) {return new Variable("y"); })(pos0);
          }
          if (result0 === null) {
            pos = pos0;
          }
        }
        return result0;
      }
      
      function parse_ws() {
        var result0, result1;
        
        result0 = [];
        if (input.charCodeAt(pos) === 32) {
          result1 = " ";
          pos++;
        } else {
          result1 = null;
          if (reportFailures === 0) {
            matchFailed("\" \"");
          }
        }
        while (result1 !== null) {
          result0.push(result1);
          if (input.charCodeAt(pos) === 32) {
            result1 = " ";
            pos++;
          } else {
            result1 = null;
            if (reportFailures === 0) {
              matchFailed("\" \"");
            }
          }
        }
        return result0;
      }
      
      
      function cleanupExpected(expected) {
        expected.sort();
        
        var lastExpected = null;
        var cleanExpected = [];
        for (var i = 0; i < expected.length; i++) {
          if (expected[i] !== lastExpected) {
            cleanExpected.push(expected[i]);
            lastExpected = expected[i];
          }
        }
        return cleanExpected;
      }
      
      function computeErrorPosition() {
        /*
         * The first idea was to use |String.split| to break the input up to the
         * error position along newlines and derive the line and column from
         * there. However IE's |split| implementation is so broken that it was
         * enough to prevent it.
         */
        
        var line = 1;
        var column = 1;
        var seenCR = false;
        
        for (var i = 0; i < Math.max(pos, rightmostFailuresPos); i++) {
          var ch = input.charAt(i);
          if (ch === "\n") {
            if (!seenCR) { line++; }
            column = 1;
            seenCR = false;
          } else if (ch === "\r" || ch === "\u2028" || ch === "\u2029") {
            line++;
            column = 1;
            seenCR = true;
          } else {
            column++;
            seenCR = false;
          }
        }
        
        return { line: line, column: column };
      }
      
      
      
      	// third party libraries
      	//set.js ==> https://github.com/jau/SetJS/blob/master/src/Set.js
      	/*
      	 * Copyright (c) 2011 Marcelo Criscuolo (criscuolo.marcelo [at] gmail [dot] com)
      	 * Released under the MIT License.
      	 */
      
      	function Set(elements) {
      		this.bag_ = [];
      		var i;
      
      		if (arguments.length > 0) { // optional args
      			for (i=0; i < elements.length; i++) {
      				this.add(elements[i]);
      			}
      		}
      	}
      
      	Set.prototype.search = function(e, start) {
      		//TODO document this
      		var j = this.bag_.length;
      		var pivot;
      		var i = arguments.length == 2 ? start : 0;
      
      		while (i < j) {
      			pivot = i + Math.floor((j - i) / 2);
      			if (this.bag_[pivot] == e) {
      				return pivot;
      			}
      
      			if (e > this.bag_[pivot]) {
      				i = pivot + 1;
      			} else {
      				j = pivot;
      			}
      		}
      
      		return i;
      	}
      
      	Set.prototype.add = function(e) {
      		var p = this.search(e);
      		if (this.bag_[p] != e) {
      			this.bag_.splice(p, 0, e); // insert e at position p
      		}
      	}
      
      	Set.prototype.contains = function(e) {
      		var p = this.search(e);
      		return (this.bag_[p] == e);
      	}
      
      	Set.prototype.size = function() {
      		return this.bag_.length;
      	}
      
      	Set.prototype.getElements = function() {
      		return this.bag_;
      	}
      
      	Set.prototype.equals = function(otherSet) {
      		if (this.size() != otherSet.size()) {return false;}
      		var i;
      		for (i=0; i < this.bag_.length; i++) {
      			if (this.bag_[i] != otherSet.bag_[i]) {
      				return false;
      			}
      		}
      
      		return true;
      	}
      
      	Set.prototype.difference = function(otherSet) {
      		var result = new Set();
      
      		if (this.size() == 0) {return result;}
      		if (otherSet.size() == 0) {
      			result.bag_ = this.bag_.slice(0);
      			return result;
      		}
      
      		var i;
      		var j = 0;
      		for (i=0; i < this.bag_.length; i++) {
      			if (this.bag_[i] > otherSet.bag_[j]) {
      				j = otherSet.search(this.bag_[i], j); // finds First otherSet[j] Not Smaller than this[i]
      				if (j == otherSet.bag_.length) {break;} // end of otherSet
      			}
      
      			if (this.bag_[i] < otherSet.bag_[j]) {
      				result.bag_.push(this.bag_[i]);
      			}
      		}
      		result.bag_ = result.bag_.concat(this.bag_.slice(i)); // adds the remaining elements, if there are any
      
      		return result;
      	}
      
      	Set.prototype.intersection = function(otherSet) {
      		var result = new Set();
      		if ((this.size() == 0) || (otherSet.size() == 0)) {return result;}
      
      		var i;
      		var j = 0;
      		for (i=0; i < this.bag_.length; i++) {
      			j = otherSet.search(this.bag_[i], j); // finds First otherSet[j] Not Smaller than this[i]
      			if (j == otherSet.bag_.length) {break;} // end of otherSet
      
      			if (this.bag_[i] == otherSet.bag_[j]) {
      				result.bag_.push(this.bag_[i]);
      			}
      		}
      
      		return result;
      	}
      
      	Set.prototype.union = function(otherSet) {
      		var result = new Set();
      		if ((this.size() == 0) && (otherSet.size() == 0)) {return result;}
      
      		var base, merged;
      		if (this.size() > otherSet.size()) {
      			base = this;
      			merged = otherSet;
      		} else {
      			base = otherSet;
      			merged = this;
      		}
      
      		result.bag_ = base.bag_.slice(0); // make a copy
      		var i;
      		for (i=0; i < merged.bag_.length; i++) {
      			result.add(merged.bag_[i]); // add() doesn't allow repetition
      		}
      
      		return result;
      	}
      	//end set.js
      
      	
      
              // Math functions
      	/**
      	 * "ooperators are simple function which have a name
               *  they are used in binary expressions, the name helps recognizing themperators"
      	 */
      	function add(a,b) {
      		this.name = "add";
      		return a+b;
      	}
      
      	function sub(a,b) {
      		this.name = "sub";
      		return a-b;
      	}
      
      	function mul(a,b) {
      		this.name = "mul";
      		return a*b;
      	}
      
      	function div(a,b) {
      		this.name = "div";
      		return a/b;
      	}
      
      	function pow(a,b) {
      		this.name = "pow";
      		return Math.pow(a,b);
      	}
      
      	function minus(a) {
      		// unary minus
      		this.name = "minus";
      		return -a;
      	}
      
      	/* they are objects, which have
      	 * @param name of he the function
      	 * @param val the argument passed to the function
      	 * @method derivate: takes a variablename and returns the derivate
      	 *                   respecting that  variable
      	 * @method eval: takes an enviroment (a mapping from names to values)
      	 *               and returns the function evaluated in that context// "functions"
      	 */
      	
      	function exp(val) {
      		this.name = "exp";
      		this.val = val;
      		this.derivate = function(varname) {
      			var inner = val.derivate(varname);
      			return new BinaryExpression(mul, inner, new exp(this.val));
      		}
      		this.eval = function(env) {
      			return Math.exp(this.val.eval(env));
      		}
      	}
      
      	function log(val) {
      		this.name = "log";
      		this.val = val;
      		this.derivate = function(varname) {
      			var inner = this.val.derivate(varname);
      			return new BinaryExpression(div, inner, this.val);
      		}
      		this.eval = function(env) {
      			return Math.log(this.val.eval(env));
      		}
      	}
      
      	function log2(val) {
      		this.name = "log2";
      		this.val = val;
      		this.derivate = function(varname) {
      			var outer = new BinaryExpression(div, new Num(1), new BinaryExpression(mul, new Num(Math.LN2), this.val)); // 1/(val*ln(2))
      			var inner = val.derivate(varname);
      			return new BinaryExpression(mul, outer, inner); 
      		}
      		this.eval = function(env) {
      			return Math.log(this.val.eval(env))/Math.LN2;
      		}
      	}
      
      	function log10(val) {
      		this.name = "log10";
      		this.val = val;
      		this.derivate = function(varname) {
      			var outer = new BinaryExpression(div, new Num(1), new BinaryExpression(mul, new Num(Math.LN10), this.val)); // 1/(val*ln(10))
      			var inner = val.derivate(varname);
      			return new BinaryExpression(mul, outer, inner); 
      		}
      		this.eval = function(env) {
      			return Math.log(val.eval(env))/Math.LN10;
      		}
      	}
      
      	function sqrt(val) {
      		this.name = "sqrt";
      		this.val = val;
      		this.derivate = function(varname) {
      			var inner = val.derivate(varname);
      			return new BinaryExpression(div, inner, new BinaryExpression(mul, new Num(2), new Func(sqrt, this.val)));
      		}
      		this.eval = function(env) {
      			return Math.sqrt(val.eval(env));
      		}
      	}
      
      	function sin(val) {
      		this.name = "sin";
      		this.val = val;
      		this.derivate = function(varname) {
      			var inner = this.val.derivate(varname);
      			var outer = new Func(cos, this.val);
      			return new BinaryExpression(mul, inner, outer);
      		}
      		this.eval = function(env) {
      			return Math.sin(this.val.eval(env));
      		}
      	}
      
      	function cos(val) {
      		this.name = "cos";
      		this.val = val;
      		this.derivate = function(varname) {
      			var inner = this.val.derivate(varname);
      			var outer = new UnaryExpression(minus, new Func(sin, this.val));
      			return new BinaryExpression(mul, inner, outer);
      		}
      		this.eval = function(env) {
      			return Math.cos(this.val.eval(env));
      		}
      	}
      
      	function tan(val) {
      		this.name = "tan";
      		this.val = val;
      		this.derivate = function(varname) {
      			var inner = this.val.derivate(varname);
      			var t2 = new BinaryExpression(mul, new Func(cos, this.val), new Func(cos, this.val));
      			return new BinaryExpression(div, inner, t2);
      		}
      		this.eval = function(env) {
      			return Math.tan(this.val.eval(env));
      		}
      	}
      
      	function cot(val) {
      		this.name = "cot";
      		this.val = val;
      		this.derivate = function(varname) {
      			var inner = this.val.derivate(varname);
      			var sin_ = new Func(sin, val);
      			var sinquad = new BinaryExpression(mul, sin_, sin_);
      			return new BinaryExpression(div, new UnaryExpression(minus, inner), sinquad);
      		}
      		this.eval = function(env) {
      			return 1/(Math.tan(val.eval(env)));
      		}
      	}
      
      	function asin(val) {
      		this.name = "arcsin";
      		this.val = val;
      		this.derivate = function(varname) {
      			var inner = this.val.derivate(varname);
      			var outer = new Func(sqrt, new BinaryExpression(sub, new Num(1), new BinaryExpression(mul, this.val, this.val)));
      			return new BinaryExpression(mul, inner, outer);
      		}
      		this.eval = function(env) {
      			return Math.asin(this.val.eval(env));
      		}
      	}
      
      	function acos(val) {
      		this.name = "arccos";
      		this.val = val;
      		this.derivate = function(varname) {
      			var inner = this.val.derivate(varname);
      			var outer = new Func(sqrt, new BinaryExpression(sub, new Num(1), new BinaryExpression(mul, this.val, this.val)));
      			return new BinaryExpression(mul, new UnaryExpression(minus, inner), outer);
      		}
      		this.eval = function(env) {
      			return Math.acos(this.val.eval(env));
      		}
      	}
      
      	function atan(val) {
      		this.name = "arctan";
      		this.val = val;
      		this.derivate = function(varname) {
      			var inner = this.val.derivate(varname);
      			var t2 = new BinaryExpression(add, new Num(1), new BinaryExpression(mul, this.val, this.val));
      			return new BinaryExpression(div, inner, t2);
      		}
      		this.eval = function(env) {
      			return Math.atan(this.val.eval(env));
      		}
      	}
      
      	function sinh(val) {
      		this.name = "sinh";
      		this.val = val;
      		this.derivate = function(varname) {
      			var outer = new Func(cosh, this.val); //cosh(val)
      			var inner = val.derivate(varname);
      			return new BinaryExpression(mul, outer, inner); 
      		}
      		this.eval = function(env) {
      			var term1 = Math.pow(Math.E, this.val.eval(env));
      			var term2 = Math.pow(Math.E, -this.val.eval(env));
      			return (term1 - term2)/2;
      		}
      	}
      
      	function cosh(val) {
      		this.name = "cosh";
      		this.val = val;
      		this.derivate = function(varname) {
      			var outer = new Func(sinh, this.val) //sinh(val)
      			var inner = val.derivate(varname);
      			return new BinaryExpression(mul, outer, inner); 
      		}
      		this.eval = function(env) {
      			var val = this.val.eval(env);
      			var term1 = Math.pow(Math.E, val);
      			var term2 = Math.pow(Math.E, -val);
      			return (term1 + term2)/2;
      		}
      	}
      
      	function tanh(val) {
      		this.name = "tanh";
      		this.val = val;
      		this.derivate = function(varname) {
      			var outer = new BinaryExpression(div, 1, new BinaryExpression(mul, new Func(cosh, this.val), new Func(cosh, this.val))) // 1/cosh^2(val)
      			var inner = val.derivate(varname);
      			return new BinaryExpression(mul, outer, inner); 
      		}
      		this.eval = function(env) {
      			var s = new sinh(this.val).eval(env);
      			var c = new cosh(this.val).eval(env);
      			return s/c;
      		}
      	}
      
      	function coth(val) {
      		this.name = "coth";
      		this.val = val;
      		this.derivate = function(varname) {
      			var outer = new UnaryExpression(minus, new BinaryExpression(div, 1, new BinaryExpression(mul, new Func(sinh, this.val), new Func(sinh, this.val)))) // 1/sinh^2(val)
      			var inner = val.derivate(varname);
      			return new BinaryExpression(mul, outer, inner); 
      		}
      		this.eval = function(env) {
      			var s = new sinh(this.val).eval(env);
      			var c = new cosh(this.val).eval(env);
      			return c/s;
      		}
      	}
      
      	function acot(val) {
      		this.name = "arccot";
      		this.val = val;
      		this.derivate = function(varname) {
      			var inner = val.derivate(varname);
      			return new BinaryExpression(div, new UnaryExpression(minus, inner), new BinaryExpression(add, new Num(1), new BinaryExpression(mul, val, val)));
      		}
      		this.eval = function(env) {
      			return Math.PI/2*Math.atan(val.eval(env));
      		}
      	}
      
      	function arsinh(val) {
      		this.name = "arsinh";
      		this.val = val;
      		this.derivate = function(varname) {
      			var outer = new BinaryExpression(div, new Num(1), new Func(sqrt, new BinaryExpression(add, new Num(1), new BinaryExpression(mul, val, val))));
      			var inner = this.val.derivate(varname);
      			return new BinaryExpression(mul, outer, inner); 
      		}
      		this.eval = function(env) {
      			var val = this.val.eval(env);
      			return Math.log(val + Math.sqrt(val*val + 1));
      		}
      	}
      
      	function arcosh(val) {
      		this.name ="arcosh";
      		this.val = val;
      		this.derivate = function(varname) {
      			var outer = new BinaryExpression(div, new Num(1), new Func(sqrt, new BinaryExpression(sub, new Num(1), new BinaryExpression(mul, val, val))));
      			var inner = this.val.derivate(varname);
      			return new BinaryExpression(mul, outer, inner); 
      		}
      		this.eval = function(env) {
      			var val = this.val.eval(env);
      			return Math.log(val + Math.sqrt(val*val - 1));
      		}
      	}
      
      	function artanh(val) {
      		this.name = "artanh";
      		this.val = val;
      		this.derivate = function(varname) {
      			var outer = new BinaryExpression(div, new Num(1), new BinaryExpression(sub, new Num(1), new BinaryExpression(mul, val, val)));
      			var inner = this.val.derivate(varname);
      			return new BinaryExpression(mul, outer, inner); 
      		}
      		this.eval = function(env) {
      			var val = this.val.eval(env);
      			return 0.5 * Math.log((1 + val)/(1 - val));
      		}
      	}
      
      	function arcoth(val) {
      		this.name = "arcoth";
      		this.val = val;
      		this.derivate = function(varname) {
      			var outer = new UnaryExpression(minus, new BinaryExpression(div, new Num(1), new BinaryExpression(sub, new BinaryExpression(mul, val, val), new Num(1))));
      			var inner = this.val.derivate(varname);
      			return new BinaryExpression(mul, outer, inner); 
      		}
      		this.eval = function(env) {
      			var val = this.val.eval(env);
      			return 0.5 * Math.log((val + 1)/(val - 1));
      		}
      	}
      
      
      	// helper methods
      	// flatten as implemented by http://tech.karbassi.com/2009/12/17/pure-javascript-flatten-array/
      	function flatten(array){
      		var flat = [];
      		for (var i = 0, l = array.length; i < l; i++){
      			var type = Object.prototype.toString.call(array[i]).split(' ').pop().split(']').shift().toLowerCase();
      			if (type) { flat = flat.concat(/^(array|collection|arguments|object)$/.test(type) ? flatten(array[i]) : array[i]); }
      		}
      		return flat;
      	}
      
      	
      
      	// Parser Objects
      	/*
      	 * Parser objects build up the parse tree. Each of them is used to
      	 * described a subexpression of a term.
      	 * All parser objects support the following methods
      	 * eval(env): will evaluate the corresponding subexpression in the
      	 *            context of env
      	 * containsVariable(varname): checks if the expressions contains the
      	 *                            variable denoted by varname
      	 * listVariables(): list all variables (variables and contstants) in an
      	 *                  expression and returns them as an array
      	 * derivate(varname): computes the (partial) derivate with respect to
      	 *                    varname
      	 */
      	function UnaryExpression(operator, expression) {
      		/**
      		 * @param operator a unary function with a name attribute
      		 * @param expression a parser object
      		 */
      		if (expression === undefined) {throw "expression is undefined";};
      		if (operator === undefined) {throw "operator is undefined";};
      		this.expression = expression;
      		this.operator = operator;
      		this.eval = function(env) {
      			return this.operator(this.expression.eval(env));
      		}
      		this.containsVariable = function(varname) {
      			return this.expression.containsVariable(varname);
      		}
      		this.listVariables = function() {
      			return this.expression.listVariables();
      		}
      		this.derivate = function(varname) {
      			if (this.operator.name === "minus") {
      				return new UnaryExpression(minus, expression.derivate(varname));
      			} else {
      				console.log("undefined operator: ");
      				console.log(this.operator.name);
      			}
      		}
      	}
      
      	function BinaryExpression(operator, left, right) {
      		/**
      		 * @param operator a binary function with a name attribute
      		 * @param left a parser object
      		 * @param right a parser object
      		 */
      		if (left === undefined) {throw "left is undefined";};
      		if (right === undefined) {throw "right is undefined";};
      		if (operator === undefined) {throw "operator is undefined";};
      		this.operator = operator;
      		this.left = left;
      		this.right = right;
      		this.eval = function(env) {
      			return this.operator(this.left.eval(env), this.right.eval(env));
      		}
      		this.containsVariable = function(varname) {
      			return (this.left.containsVariable(varname) || this.right.containsVariable(varname) );
      		}
      		this.listVariables = function() {
      			return this.left.listVariables().union(this.right.listVariables());
      		}
      		this.derivate = function(varname) {
      			var leftd = left.derivate(varname);
      			var rightd = right.derivate(varname);
      			switch (operator.name) {
      				case "add":
      					return new BinaryExpression(add, leftd, rightd);
      					break;
      				case "sub":
      					return new BinaryExpression(sub, leftd, rightd);
      					break;
      				case "mul":
      					var lnew = new BinaryExpression(mul, leftd, right);
      					var rnew = new BinaryExpression(mul, left, rightd);
      					return new BinaryExpression(add, lnew, rnew);
      					break;
      				case "div":
      					var lnew = new BinaryExpression(mul, leftd, right);
      					var rnew = new BinaryExpression(mul, left, rightd);
      					var denonimator = new BinaryExpression(mul, right, right);
      					return new BinaryExpression(div, new BinaryExpression(sub, lnew, rnew), denonimator);
      					break;
      				case "pow":
      					// handling special cases, because the
      					// general case fails for negative values
      					// checking if only base contains the variable
      					// t^n = t'*t^(n-1)*n
      					if (!right.containsVariable(varname)) {
      						var tmp1 = new BinaryExpression(sub, right, new Num(1));
      						var tmp2 = new BinaryExpression(mul, leftd, new BinaryExpression(pow, left, tmp1));
      						return new BinaryExpression(mul, right, tmp2);
      					}
      					// checking if base doesn't contain the variable
      					// f(x) = a^t(x) -> f'(x) = ln(a) * t(x) * t'(x)
      					if (!left.containsVariable(varname)) {
      						var tmp1 = new Func(log, right);
      						var tmp2 = new BinaryExpression(mul, tmp1, right);
      						return new BinaryExpression(mul, tmp2, rightd);
      					}
      					// general case:
      					// d(u^v) = v*u^(v-1)*du+u^v*ln(u)*dv
      					var tmp1 = new BinaryExpression(pow, left, new BinaryExpression(sub, right, new Num(1))); //u^(v-1)
      					var tmp2 = new BinaryExpression(mul, right, tmp1); // v*u^(v-1)
      					var tmp3 = new BinaryExpression(mul, tmp2, leftd); //v*u^(v-1)*du
      					var tmp4 = new Func(log, left); //ln(u)
      					var tmp5 = new BinaryExpression(pow, left, right); //u^v
      					var tmp6 = new BinaryExpression(mul, tmp4, rightd); //ln(u)*dv
      					var tmp7 = new BinaryExpression(mul, tmp5, tmp6); //u^v*ln(u)*dv
      					return new BinaryExpression(add, tmp3, tmp7); 
      				default:
      					console.log(operator.name);
      					throw "wtf is missing?";
      			}
      		}
      	}
      
      	function Variable(variable){ // variable in a mathmatical sense including constants
      		/**
      		 * @param variable the name of the variable
      		 */
      		if (variable === undefined) {throw "variable is undefined";};
      		this.variable = variable;
      		this.eval = function(env) {return env[this.variable];};
      		this.containsVariable = function(varname) {
      			return this.variable === varname;
      		}
      		this.listVariables = function() {
      			return new Set(this.variable);
      		}
      		this.derivate = function(varname) {
      			if (this.variable === varname) {
      				return new Num(1);
      			} else {
      				return new Num(0);
      			}
      		}
      	}
      
      	function Func(func, arg) {
      		/**
      		 * @param func a unary function with a name and a derivate
      		 *             function
      		 * @param arg a parser object passed to the function
      		 */
      		if (func === undefined) {throw "func is undefined";};
      		if (arg === undefined) {throw "arg is undefined";};
      		this.func = new func(arg);
      		this.arg = arg;
      		this.eval = function(env) {return this.func.eval(env)};
      		this.containsVariable = function(varname) {
      			return this.arg.containsVariable(varname);
      		}
      		this.listVariables = function() {
      			return this.arg.listVariables();
      		}
      		this.derivate = function(varname) {
      			return this.func.derivate(varname);
      		}
      	}
      
      	function Num(value) {
      		this.value = value;
      		this.eval = function(env) {return this.value;};
      		this.containsVariable = function(varname) {
      			return false;
      		}
      		this.listVariables = function() {
      			return new Set([]);
      		}
      		this.derivate = function(varname) {
      			return new Num(0);
      		}
      	}
      	
      
      
      
      var result = parseFunctions[startRule]();
      
      /*
       * The parser is now in one of the following three states:
       *
       * 1. The parser successfully parsed the whole input.
       *
       *    - |result !== null|
       *    - |pos === input.length|
       *    - |rightmostFailuresExpected| may or may not contain something
       *
       * 2. The parser successfully parsed only a part of the input.
       *
       *    - |result !== null|
       *    - |pos < input.length|
       *    - |rightmostFailuresExpected| may or may not contain something
       *
       * 3. The parser did not successfully parse any part of the input.
       *
       *   - |result === null|
       *   - |pos === 0|
       *   - |rightmostFailuresExpected| contains at least one failure
       *
       * All code following this comment (including called functions) must
       * handle these states.
       */
      if (result === null || pos !== input.length) {
        var offset = Math.max(pos, rightmostFailuresPos);
        var found = offset < input.length ? input.charAt(offset) : null;
        var errorPosition = computeErrorPosition();
        
        throw new this.SyntaxError(
          cleanupExpected(rightmostFailuresExpected),
          found,
          offset,
          errorPosition.line,
          errorPosition.column
        );
      }
      
      return result;
    },
    
    /* Returns the parser source code. */
    toSource: function() { return this._source; }
  };
  
  /* Thrown when a parser encounters a syntax error. */
  
  result.SyntaxError = function(expected, found, offset, line, column) {
    function buildMessage(expected, found) {
      var expectedHumanized, foundHumanized;
      
      switch (expected.length) {
        case 0:
          expectedHumanized = "end of input";
          break;
        case 1:
          expectedHumanized = expected[0];
          break;
        default:
          expectedHumanized = expected.slice(0, expected.length - 1).join(", ")
            + " or "
            + expected[expected.length - 1];
      }
      
      foundHumanized = found ? quote(found) : "end of input";
      
      return "Expected " + expectedHumanized + " but " + foundHumanized + " found.";
    }
    
    this.name = "SyntaxError";
    this.expected = expected;
    this.found = found;
    this.message = buildMessage(expected, found);
    this.offset = offset;
    this.line = line;
    this.column = column;
  };
  
  result.SyntaxError.prototype = Error.prototype;
  
  return result;
})();
